Index: branches/WebJobManager/HeuristicLab.Optimization/3.3/Algorithms/Algorithm.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Algorithms/Algorithm.cs	(revision 13593)
+++ branches/WebJobManager/HeuristicLab.Optimization/3.3/Algorithms/Algorithm.cs	(revision 13656)
@@ -37,9 +37,12 @@
   [StorableClass]
   public abstract class Algorithm : ParameterizedNamedItem, IAlgorithm {
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Event; }
-    }
-    public override Image ItemImage {
-      get {
+    public static new Image StaticItemImage
+    {
+      get { return new Bitmap(25, 25); }
+    }
+    public override Image ItemImage
+    {
+      get
+      {
         if (ExecutionState == ExecutionState.Prepared) return HeuristicLab.Common.Resources.VSImageLibrary.ExecutablePrepared;
         else if (ExecutionState == ExecutionState.Started) return HeuristicLab.Common.Resources.VSImageLibrary.ExecutableStarted;
@@ -52,7 +55,9 @@
     [Storable]
     private ExecutionState executionState;
-    public ExecutionState ExecutionState {
+    public ExecutionState ExecutionState
+    {
       get { return executionState; }
-      private set {
+      private set
+      {
         if (executionState != value) {
           executionState = value;
@@ -65,7 +70,9 @@
     [Storable]
     private TimeSpan executionTime;
-    public TimeSpan ExecutionTime {
+    public TimeSpan ExecutionTime
+    {
       get { return executionTime; }
-      protected set {
+      protected set
+      {
         executionTime = value;
         OnExecutionTimeChanged();
@@ -73,5 +80,6 @@
     }
 
-    public virtual Type ProblemType {
+    public virtual Type ProblemType
+    {
       get { return typeof(IProblem); }
     }
@@ -79,7 +87,9 @@
     [Storable]
     private IProblem problem;
-    public IProblem Problem {
+    public IProblem Problem
+    {
       get { return problem; }
-      set {
+      set
+      {
         if (problem != value) {
           if ((value != null) && !ProblemType.IsInstanceOfType(value)) throw new ArgumentException("Invalid problem type.");
@@ -97,7 +107,9 @@
     [Storable]
     private bool storeAlgorithmInEachRun;
-    public bool StoreAlgorithmInEachRun {
+    public bool StoreAlgorithmInEachRun
+    {
       get { return storeAlgorithmInEachRun; }
-      set {
+      set
+      {
         if (storeAlgorithmInEachRun != value) {
           storeAlgorithmInEachRun = value;
@@ -112,7 +124,9 @@
     [Storable]
     private RunCollection runs;
-    public RunCollection Runs {
+    public RunCollection Runs
+    {
       get { return runs; }
-      protected set {
+      protected set
+      {
         if (value == null) throw new ArgumentNullException();
         if (runs != value) {
@@ -124,5 +138,6 @@
     }
 
-    public virtual IEnumerable<IOptimizer> NestedOptimizers {
+    public virtual IEnumerable<IOptimizer> NestedOptimizers
+    {
       get { return Enumerable.Empty<IOptimizer>(); }
     }
Index: branches/WebJobManager/HeuristicLab.Optimization/3.3/MetaOptimizers/BatchRun.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/MetaOptimizers/BatchRun.cs	(revision 13593)
+++ branches/WebJobManager/HeuristicLab.Optimization/3.3/MetaOptimizers/BatchRun.cs	(revision 13656)
@@ -41,9 +41,12 @@
     public string Filename { get; set; }
 
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Event; }
-    }
-    public override Image ItemImage {
-      get {
+    public static new Image StaticItemImage
+    {
+      get { return new Bitmap(25, 25); }
+    }
+    public override Image ItemImage
+    {
+      get
+      {
         if (ExecutionState == ExecutionState.Prepared) return HeuristicLab.Common.Resources.VSImageLibrary.BatchRunPrepared;
         else if (ExecutionState == ExecutionState.Started) return HeuristicLab.Common.Resources.VSImageLibrary.BatchRunStarted;
@@ -56,7 +59,9 @@
     [Storable]
     private ExecutionState executionState;
-    public ExecutionState ExecutionState {
+    public ExecutionState ExecutionState
+    {
       get { return executionState; }
-      private set {
+      private set
+      {
         if (executionState != value) {
           executionState = value;
@@ -69,6 +74,8 @@
     [Storable]
     private TimeSpan executionTime;
-    public TimeSpan ExecutionTime {
-      get {
+    public TimeSpan ExecutionTime
+    {
+      get
+      {
         if ((Optimizer != null) && (Optimizer.ExecutionState != ExecutionState.Stopped))
           return executionTime + Optimizer.ExecutionTime;
@@ -76,5 +83,6 @@
           return executionTime;
       }
-      private set {
+      private set
+      {
         executionTime = value;
         OnExecutionTimeChanged();
@@ -87,7 +95,9 @@
     [Storable]
     private IOptimizer optimizer;
-    public IOptimizer Optimizer {
+    public IOptimizer Optimizer
+    {
       get { return optimizer; }
-      set {
+      set
+      {
         if (optimizer != value) {
           if (optimizer != null) {
@@ -110,5 +120,6 @@
     #region Backwards compatible code (remove with 3.4)
     [Storable(AllowOneWay = true)]
-    private IAlgorithm algorithm {
+    private IAlgorithm algorithm
+    {
       set { optimizer = value; }
     }
@@ -117,7 +128,9 @@
     [Storable]
     private int repetitions;
-    public int Repetitions {
+    public int Repetitions
+    {
       get { return repetitions; }
-      set {
+      set
+      {
         if (repetitions != value) {
           repetitions = value;
@@ -130,7 +143,9 @@
     [Storable]
     private int repetitionsCounter;
-    public int RepetitionsCounter {
+    public int RepetitionsCounter
+    {
       get { return repetitionsCounter; }
-      private set {
+      private set
+      {
         if (value != repetitionsCounter) {
           repetitionsCounter = value;
@@ -142,7 +157,9 @@
     [Storable]
     private RunCollection runs;
-    public RunCollection Runs {
+    public RunCollection Runs
+    {
       get { return runs; }
-      private set {
+      private set
+      {
         if (value == null) throw new ArgumentNullException();
         if (runs != value) {
@@ -154,6 +171,8 @@
     }
 
-    public IEnumerable<IOptimizer> NestedOptimizers {
-      get {
+    public IEnumerable<IOptimizer> NestedOptimizers
+    {
+      get
+      {
         if (Optimizer == null) yield break;
 
Index: branches/WebJobManager/HeuristicLab.Optimization/3.3/MetaOptimizers/Experiment.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/MetaOptimizers/Experiment.cs	(revision 13593)
+++ branches/WebJobManager/HeuristicLab.Optimization/3.3/MetaOptimizers/Experiment.cs	(revision 13656)
@@ -40,9 +40,12 @@
     public string Filename { get; set; }
 
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Event; }
-    }
-    public override Image ItemImage {
-      get {
+    public static new Image StaticItemImage
+    {
+      get { return new Bitmap(25, 25); }
+    }
+    public override Image ItemImage
+    {
+      get
+      {
         if (ExecutionState == ExecutionState.Prepared) return HeuristicLab.Common.Resources.VSImageLibrary.ExperimentPrepared;
         else if (ExecutionState == ExecutionState.Started) return HeuristicLab.Common.Resources.VSImageLibrary.ExperimentStarted;
@@ -55,7 +58,9 @@
     [Storable]
     private ExecutionState executionState;
-    public ExecutionState ExecutionState {
+    public ExecutionState ExecutionState
+    {
       get { return executionState; }
-      private set {
+      private set
+      {
         if (executionState != value) {
           executionState = value;
@@ -68,7 +73,9 @@
     [Storable]
     private TimeSpan executionTime;
-    public TimeSpan ExecutionTime {
+    public TimeSpan ExecutionTime
+    {
       get { return executionTime; }
-      private set {
+      private set
+      {
         executionTime = value;
         OnExecutionTimeChanged();
@@ -78,5 +85,6 @@
     [Storable]
     private OptimizerList optimizers;
-    public OptimizerList Optimizers {
+    public OptimizerList Optimizers
+    {
       get { return optimizers; }
     }
@@ -84,7 +92,9 @@
     [Storable]
     private RunCollection runs;
-    public RunCollection Runs {
+    public RunCollection Runs
+    {
       get { return runs; }
-      private set {
+      private set
+      {
         if (value == null) throw new ArgumentNullException();
         if (runs != value) {
@@ -96,6 +106,8 @@
     }
 
-    public IEnumerable<IOptimizer> NestedOptimizers {
-      get {
+    public IEnumerable<IOptimizer> NestedOptimizers
+    {
+      get
+      {
         if (Optimizers == null) yield break;
 
Index: branches/WebJobManager/HeuristicLab.Optimization/3.3/MetaOptimizers/TimeLimitRun.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/MetaOptimizers/TimeLimitRun.cs	(revision 13593)
+++ branches/WebJobManager/HeuristicLab.Optimization/3.3/MetaOptimizers/TimeLimitRun.cs	(revision 13656)
@@ -43,8 +43,10 @@
 
     #region ItemImage
-    public static new Image StaticItemImage {
-      get { return VSImageLibrary.Event; }
-    }
-    public override Image ItemImage {
+    public static new Image StaticItemImage
+    {
+      get { return new Bitmap(25, 25); }
+    }
+    public override Image ItemImage
+    {
       get { return (Algorithm != null) ? Algorithm.ItemImage : VSImageLibrary.ExecutableStopped; }
     }
@@ -56,7 +58,9 @@
     [Storable]
     private TimeSpan maximumExecutionTime;
-    public TimeSpan MaximumExecutionTime {
+    public TimeSpan MaximumExecutionTime
+    {
       get { return maximumExecutionTime; }
-      set {
+      set
+      {
         if (maximumExecutionTime == value) return;
         maximumExecutionTime = value;
@@ -69,7 +73,9 @@
     [Storable]
     private ObservableList<TimeSpan> snapshotTimes;
-    public ObservableList<TimeSpan> SnapshotTimes {
+    public ObservableList<TimeSpan> SnapshotTimes
+    {
       get { return snapshotTimes; }
-      set {
+      set
+      {
         if (snapshotTimes == value) return;
         snapshotTimes = value;
@@ -83,7 +89,9 @@
     private bool storeAlgorithmInEachSnapshot;
     [Storable]
-    public bool StoreAlgorithmInEachSnapshot {
+    public bool StoreAlgorithmInEachSnapshot
+    {
       get { return storeAlgorithmInEachSnapshot; }
-      set {
+      set
+      {
         if (storeAlgorithmInEachSnapshot == value) return;
         storeAlgorithmInEachSnapshot = value;
@@ -94,7 +102,9 @@
     [Storable]
     private RunCollection snapshots;
-    public RunCollection Snapshots {
+    public RunCollection Snapshots
+    {
       get { return snapshots; }
-      set {
+      set
+      {
         if (snapshots == value) return;
         snapshots = value;
@@ -104,9 +114,11 @@
 
     #region Inherited Properties
-    public ExecutionState ExecutionState {
+    public ExecutionState ExecutionState
+    {
       get { return (Algorithm != null) ? Algorithm.ExecutionState : ExecutionState.Stopped; }
     }
 
-    public TimeSpan ExecutionTime {
+    public TimeSpan ExecutionTime
+    {
       get { return (Algorithm != null) ? Algorithm.ExecutionTime : TimeSpan.FromSeconds(0); }
     }
@@ -114,7 +126,9 @@
     [Storable]
     private IAlgorithm algorithm;
-    public IAlgorithm Algorithm {
+    public IAlgorithm Algorithm
+    {
       get { return algorithm; }
-      set {
+      set
+      {
         if (algorithm == value) return;
         if (algorithm != null) DeregisterAlgorithmEvents();
@@ -130,7 +144,9 @@
     [Storable]
     private RunCollection runs;
-    public RunCollection Runs {
+    public RunCollection Runs
+    {
       get { return runs; }
-      private set {
+      private set
+      {
         if (value == null) throw new ArgumentNullException();
         if (runs == value) return;
@@ -140,6 +156,8 @@
     }
 
-    public IEnumerable<IOptimizer> NestedOptimizers {
-      get {
+    public IEnumerable<IOptimizer> NestedOptimizers
+    {
+      get
+      {
         if (Algorithm == null) yield break;
         yield return Algorithm;
Index: branches/WebJobManager/HeuristicLab.Optimization/3.3/Problems/Problem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Problems/Problem.cs	(revision 13593)
+++ branches/WebJobManager/HeuristicLab.Optimization/3.3/Problems/Problem.cs	(revision 13656)
@@ -35,10 +35,12 @@
   public abstract class Problem : ParameterizedNamedItem, IProblem {
     private const string OperatorsParameterName = "Operators";
-    public IFixedValueParameter<ItemCollection<IItem>> OperatorsParameter {
+    public IFixedValueParameter<ItemCollection<IItem>> OperatorsParameter
+    {
       get { return (IFixedValueParameter<ItemCollection<IItem>>)Parameters[OperatorsParameterName]; }
     }
 
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Type; }
+    public static new Image StaticItemImage
+    {
+      get { return new Bitmap(25, 25); }
     }
 
@@ -85,6 +87,8 @@
     #region Backwards compatible code, remove with 3.4
     [Storable(Name = "Operators", AllowOneWay = true)]
-    private IEnumerable<IOperator> StorableOperators {
-      set {
+    private IEnumerable<IOperator> StorableOperators
+    {
+      set
+      {
         IParameter operatorsParam;
         if (Parameters.TryGetValue(OperatorsParameterName, out operatorsParam)) {
@@ -102,6 +106,8 @@
     }
     #endregion
-    protected ItemCollection<IItem> Operators {
-      get {
+    protected ItemCollection<IItem> Operators
+    {
+      get
+      {
         // BackwardsCompatibility3.3
         #region Backwards compatible code, remove with 3.4
@@ -120,5 +126,6 @@
     }
 
-    public virtual IEnumerable<IParameterizedItem> ExecutionContextItems {
+    public virtual IEnumerable<IParameterizedItem> ExecutionContextItems
+    {
       get { yield return this; }
     }
Index: branches/WebJobManager/HeuristicLab.Optimization/3.3/Problems/UserDefinedProblem.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Problems/UserDefinedProblem.cs	(revision 13593)
+++ branches/WebJobManager/HeuristicLab.Optimization/3.3/Problems/UserDefinedProblem.cs	(revision 13656)
@@ -43,43 +43,56 @@
     public string Filename { get; set; }
 
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Type; }
-    }
-    public new ParameterCollection Parameters {
+    public static new Image StaticItemImage
+    {
+      get { return new Bitmap(25, 25); }
+    }
+    public new ParameterCollection Parameters
+    {
       get { return base.Parameters; }
     }
-    IKeyedItemCollection<string, IParameter> IParameterizedItem.Parameters {
+    IKeyedItemCollection<string, IParameter> IParameterizedItem.Parameters
+    {
       get { return Parameters; }
     }
 
     #region Parameters
-    public IValueParameter<ISingleObjectiveEvaluator> EvaluatorParameter {
+    public IValueParameter<ISingleObjectiveEvaluator> EvaluatorParameter
+    {
       get { return (IValueParameter<ISingleObjectiveEvaluator>)Parameters["Evaluator"]; }
     }
-    public ValueParameter<BoolValue> MaximizationParameter {
+    public ValueParameter<BoolValue> MaximizationParameter
+    {
       get { return (ValueParameter<BoolValue>)Parameters["Maximization"]; }
     }
-    IParameter ISingleObjectiveHeuristicOptimizationProblem.MaximizationParameter {
+    IParameter ISingleObjectiveHeuristicOptimizationProblem.MaximizationParameter
+    {
       get { return MaximizationParameter; }
     }
-    public ValueParameter<ISolutionCreator> SolutionCreatorParameter {
+    public ValueParameter<ISolutionCreator> SolutionCreatorParameter
+    {
       get { return (ValueParameter<ISolutionCreator>)Parameters["SolutionCreator"]; }
     }
-    IParameter IHeuristicOptimizationProblem.SolutionCreatorParameter {
+    IParameter IHeuristicOptimizationProblem.SolutionCreatorParameter
+    {
       get { return SolutionCreatorParameter; }
     }
-    IParameter IHeuristicOptimizationProblem.EvaluatorParameter {
+    IParameter IHeuristicOptimizationProblem.EvaluatorParameter
+    {
       get { return EvaluatorParameter; }
     }
-    public OptionalValueParameter<DoubleValue> BestKnownQualityParameter {
+    public OptionalValueParameter<DoubleValue> BestKnownQualityParameter
+    {
       get { return (OptionalValueParameter<DoubleValue>)Parameters["BestKnownQuality"]; }
     }
-    IParameter ISingleObjectiveHeuristicOptimizationProblem.BestKnownQualityParameter {
+    IParameter ISingleObjectiveHeuristicOptimizationProblem.BestKnownQualityParameter
+    {
       get { return BestKnownQualityParameter; }
     }
-    public OptionalValueParameter<IScope> BestKnownSolutionParameter {
+    public OptionalValueParameter<IScope> BestKnownSolutionParameter
+    {
       get { return (OptionalValueParameter<IScope>)Parameters["BestKnownSolution"]; }
     }
-    public ValueParameter<ItemList<IItem>> OperatorsParameter {
+    public ValueParameter<ItemList<IItem>> OperatorsParameter
+    {
       get { return (ValueParameter<ItemList<IItem>>)Parameters["Operators"]; }
     }
@@ -87,34 +100,43 @@
 
     #region Properties
-    public BoolValue Maximization {
+    public BoolValue Maximization
+    {
       get { return MaximizationParameter.Value; }
       set { MaximizationParameter.Value = value; }
     }
-    public ISolutionCreator SolutionCreator {
+    public ISolutionCreator SolutionCreator
+    {
       get { return SolutionCreatorParameter.Value; }
       set { SolutionCreatorParameter.Value = value; }
     }
-    ISolutionCreator IHeuristicOptimizationProblem.SolutionCreator {
+    ISolutionCreator IHeuristicOptimizationProblem.SolutionCreator
+    {
       get { return SolutionCreatorParameter.Value; }
     }
-    public ISingleObjectiveEvaluator Evaluator {
+    public ISingleObjectiveEvaluator Evaluator
+    {
       get { return EvaluatorParameter.Value; }
       set { EvaluatorParameter.Value = value; }
     }
-    ISingleObjectiveEvaluator ISingleObjectiveHeuristicOptimizationProblem.Evaluator {
+    ISingleObjectiveEvaluator ISingleObjectiveHeuristicOptimizationProblem.Evaluator
+    {
       get { return EvaluatorParameter.Value; }
     }
-    IEvaluator IHeuristicOptimizationProblem.Evaluator {
+    IEvaluator IHeuristicOptimizationProblem.Evaluator
+    {
       get { return EvaluatorParameter.Value; }
     }
-    public DoubleValue BestKnownQuality {
+    public DoubleValue BestKnownQuality
+    {
       get { return BestKnownQualityParameter.Value; }
       set { BestKnownQualityParameter.Value = value; }
     }
-    public IEnumerable<IItem> Operators {
+    public IEnumerable<IItem> Operators
+    {
       get { return OperatorsParameter.Value; }
     }
 
-    public IEnumerable<IParameterizedItem> ExecutionContextItems {
+    public IEnumerable<IParameterizedItem> ExecutionContextItems
+    {
       get { yield return this; }
     }
@@ -250,5 +272,6 @@
       #region ISingleObjectiveEvaluator Members
 
-      public ILookupParameter<DoubleValue> QualityParameter {
+      public ILookupParameter<DoubleValue> QualityParameter
+      {
         get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
       }
@@ -276,6 +299,7 @@
       #endregion
 
-      public static new Image StaticItemImage {
-        get { return HeuristicLab.Common.Resources.VSImageLibrary.Method; }
+      public static new Image StaticItemImage
+      {
+        get { return new Bitmap(25, 25); }
       }
     }
Index: branches/WebJobManager/HeuristicLab.Optimization/3.3/ResultCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/ResultCollection.cs	(revision 13593)
+++ branches/WebJobManager/HeuristicLab.Optimization/3.3/ResultCollection.cs	(revision 13656)
@@ -21,4 +21,5 @@
 
 using System.Collections.Generic;
+using System.Drawing;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -41,6 +42,7 @@
     }
 
-    public static new System.Drawing.Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Object; }
+    public static new System.Drawing.Image StaticItemImage
+    {
+      get { return new Bitmap(25, 25); }
     }
 
Index: branches/WebJobManager/HeuristicLab.Optimization/3.3/Termination/MultiTerminator.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Termination/MultiTerminator.cs	(revision 13593)
+++ branches/WebJobManager/HeuristicLab.Optimization/3.3/Termination/MultiTerminator.cs	(revision 13656)
@@ -35,9 +35,11 @@
   [StorableClass]
   public sealed class MultiTerminator : CheckedMultiOperator<ITerminator>, ITerminator {
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.FlagRed; }
+    public static new Image StaticItemImage
+    {
+      get { return new Bitmap(25, 25); }
     }
 
-    public ILookupParameter<BoolValue> TerminateParameter {
+    public ILookupParameter<BoolValue> TerminateParameter
+    {
       get { return (ILookupParameter<BoolValue>)Parameters["Terminate"]; }
     }
Index: branches/WebJobManager/HeuristicLab.Optimization/3.3/Termination/Terminator.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Termination/Terminator.cs	(revision 13593)
+++ branches/WebJobManager/HeuristicLab.Optimization/3.3/Termination/Terminator.cs	(revision 13656)
@@ -33,9 +33,11 @@
   [StorableClass]
   public abstract class Terminator : SingleSuccessorOperator, ITerminator {
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.FlagRed; }
+    public static new Image StaticItemImage
+    {
+      get { return new Bitmap(25, 25); }
     }
 
-    public ILookupParameter<BoolValue> TerminateParameter {
+    public ILookupParameter<BoolValue> TerminateParameter
+    {
       get { return (ILookupParameter<BoolValue>)Parameters["Terminate"]; }
     }